<template>
  <div class="task-list">
    <div class="task-list__header">
      <span class="task-list__name">Название</span>
      <span class="task-list__date">Дата</span>
      <span class="task-list__status">Статус</span>
      <span class="task-list__control"></span>
    </div>
    <div class="task-list__elem" v-for="(task, id) in tasks" :key="id">
      <span class="task-list__name"> {{ task.name }}</span>
      <span class="task-list__date">{{ task.deadline }}</span>
      <span class="task-list__status">{{ task.status }}</span>
      <span class="task-list__control">
        <AppButton
          :theme="buttonThemes.ico"
          :icon="buttonIcons.edit"
          @click="editTask(task.id)"
        />
        <AppButton
          :theme="buttonThemes.ico"
          :icon="buttonIcons.remove"
          @click="askForRemoveTask(task.id)"
        />
      </span>
    </div>
  </div>
  <ModalDialog
    title="Удалить выбранное ?"
    text="Выбранные вами объекты удалятся без возможности восстановления."
    :show="showDialog"
  >
    <template #actions>
      <AppButton :theme="buttonThemes.light" @click="cancelRemove">
        Отмена
      </AppButton>
      <AppButton :theme="buttonThemes.prime" @click="removeTask">
        Удалить
      </AppButton>
    </template>
  </ModalDialog>
</template>

<script>
import AppButton, {
  themes as buttonThemes,
  icons as buttonIcons,
} from "@/components/UI/AppButton.vue";
import ModalDialog from "@/components/ModalDialog.vue";
import baseApi from "@/api/baseApi";
import store from "@/store";
import { DateTime } from "luxon";

export default {
  name: "TasksTable",
  components: { ModalDialog, AppButton },
  data() {
    return {
      buttonIcons,
      buttonThemes,
      showDialog: false,
      tasks: [],
      taskForRemove: null,
    };
  },
  props: {},
  methods: {
    editTask(id) {
      const task = this.tasks.find((item) => item.id === id);
      if (task) {
        this.$store.commit("changeEditMode", true);
        this.$router.push(`/task/edit/${task.id}`);
      }
    },
    askForRemoveTask(id) {
      const task = this.tasks.find((item) => item.id === id);
      if (task) {
        this.showDialog = true;
        this.taskForRemove = task;
      }
    },
    setRemove() {
      const toRemove = this.tasks.findIndex(
        (item) => item.id === this.taskForRemove.id
      );
      if (toRemove !== -1) {
        this.tasks.splice(toRemove, 1);
        this.showDialog = false;
        this.taskForRemove = null;
      }
    },
    removeTask() {
      baseApi.delete("/task/" + this.taskForRemove.id, {}, {}).then((res) => {
        if (res.data === true) {
          this.setRemove();
        }
      });
    },
    cancelRemove() {
      this.showDialog = false;
      this.taskForRemove = null;
    },
    fetch() {
      baseApi
        .get("tasks/", {}, {})
        .then((res) => {
          this.tasks = res.data;
          this.tasks = this.tasks.map((task) => ({
            ...task,
            deadline: DateTime.fromISO(task.deadline).toFormat("dd.LL.y"),
          }));
        })
        .catch((e) => {
          console.error(e);
        })
        .finally(() => {});
    },
  },
  computed: {
    DateTime() {
      return DateTime;
    },
    isEditStatus: {
      get: () => store.state.isEditMode,
      set: (val) => store.commit("changeEditMode", val),
    },
  },
  mounted() {
    this.fetch();
  },
};
</script>

<style>
.task-list {
  display: block;
  width: 100%;
  margin-top: 40px;
}
.task-list th {
  color: #10171e;
  font-weight: 500;
}

.task-list__header {
  width: calc(100% - 88px);
  margin: 18px auto;
  font-weight: 500;
}

.task-list__header span,
.task-list__elem span {
  display: inline-block;
  white-space: nowrap;
  line-height: 24px;
  overflow: hidden;
  text-overflow: ellipsis;
}

.task-list .task-list__name {
  min-width: 300px;
  text-align: left;
  width: 30%;
  max-width: 30%;
}

.task-list .task-list__date {
  min-width: 100px;
  text-align: center;
  width: 20%;
}
.task-list .task-list__status {
  min-width: 100px;
  text-align: center;
  width: 20%;
}
.task-list .task-list__control {
  min-width: 300px;
  text-align: right;
  width: 29%;
}

.task-list__elem {
  padding: 25px 33px;
  background: #f6f6f6;
  display: block;
  width: 100%;
  border-radius: 6px;
  margin: 6px 0;
}
</style>
